import numpy as np
import matplotlib.pyplot as plt
from matplotlib import cm
import pandas as pd


excel = pd.read_excel("data_figure_2-4.xlsx")
excel_dropped = pd.read_excel("data_figure_2-4.xlsx")

excel_dropped.drop('start', axis=1)
excel_dropped.drop('stop', axis=1)



grps = excel.groupby([ "auto_cat", "QI_subcat"], as_index=False)
grps_red = excel_dropped.groupby([ "auto_cat", "QI_subcat"])

means = grps.mean()
stds = grps_red.std().reset_index()

## Set colormap

fig, axs = plt.subplots(3,2, figsize=(20,25))
for i, name in enumerate(means['auto_cat'].unique()):
    ax = axs.ravel()[i]
    auto_cat_means = means.loc[means['auto_cat'] == name]
    auto_cat_stds = stds.loc[stds['auto_cat'] == name]
    means_qi_megatrends = np.mean(np.stack((auto_cat_means['start'], auto_cat_means['stop'])), axis=0) #, 'stop'
    num_points = len(auto_cat_means)
    colors = [cm.cool(x) for x in np.linspace(0,1,num_points)]
    clrmap = clr.LinearSegmentedColormap.from_list("", ["#2640ffff","red"])
    for k in range(num_points):
        kk = k + i*num_points
        x = auto_cat_means['relevance'][kk]
        y = means_qi_megatrends[k]
        xerr =  auto_cat_stds['relevance'][kk]/2
        yerr = (auto_cat_means['stop'][kk] - auto_cat_means['start'][kk])/2
        
        distance = np.sqrt(x**2 + y**2)
        distance_norm = distance/np.sqrt(100**2+100**2)
        color = clrmap(distance_norm)
        
        ax.errorbar(x, y, xerr=xerr, yerr=yerr, fmt = 'o', color=color, capsize=5)
        ax.text(x+1,y+1, str(auto_cat_means['QI_subcat'][kk]),fontsize=14)

    ax.axhline(33, color = 'black', alpha=0.5, linestyle='--')
    ax.axhline(66, color = 'black', alpha=0.5, linestyle='--')
    ax.set_ylim([0,100])
    ax.set_xlim([0,100])
    ax.text(99,99, name, fontsize=18, horizontalalignment='right',
        verticalalignment='top')
    ax.text(-1,99, 'ABCDEFGH'[i], fontsize=30, horizontalalignment='right',
        verticalalignment='bottom')
    ax.set_yticks([])
    ax.set_xticks([])
    ax.set_xlabel('Automotive pre-production\n relevance', fontsize = 18)
    ax.set_ylabel('Quantum internet\n functionality relevance', fontsize = 18)
    
plt.savefig(fig2.pdf", bbox_inches='tight')
plt.show()